﻿using System.Text.Encodings.Web;
using System.Text.Json;

SerializeMessage();

ReadMessage();

static void SerializeMessage()
{

    var house = new House()
    {
        Address = "123 Main St",
        City = "Seattle",
        State = "WA",
        Owner = new Person() 
        {
            Name = "Alan Adams",
            Age = 11
        }
    };

    var message = new Message()
    {
        MessageId = Guid.NewGuid(),
        MessageBody = JsonSerializer.Serialize(house), // serialize the payload
        MessageSource = "Somewhere",
        SentTimestamp = DateTime.Now,
        SenderId = "12345"
    };

    QueueEvent queueEvent = new QueueEvent();
    queueEvent.Messages = new Message[] { message };

    var options = new JsonSerializerOptions
    {
        WriteIndented = true,
        Encoder = JavaScriptEncoder.UnsafeRelaxedJsonEscaping
    };
    string jsonString = JsonSerializer.Serialize(queueEvent, options);
    File.WriteAllText("messageWithSerializedPayload.json", jsonString);
}

static void ReadMessage()
{
    string fileName = "messageWithSerializedPayload.json";
    string jsonString = File.ReadAllText(fileName);

    QueueEvent queueEvent = JsonSerializer.Deserialize<QueueEvent>(jsonString)!;
    foreach (var message in queueEvent.Messages)
    {
        var house = message.ExtractInnerObject<House>(); // this <House> is the type of the inner object, but can be any type
        Console.WriteLine(house);
    }
}